/* de44d.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    doublereal wc1, wc2, wc3;
    doublereal hd2, hd4, hold;
    integer lasn;
} com70d_;

#define com70d_1 com70d_

/* Subroutine */ int de44d_c(S_fp f, integer *m, integer *k, integer *iniapr, 
	integer *imax, integer *jstart, doublereal *yx, doublereal *x, 
	doublereal *xj0, doublereal *au, doublereal *ajk, doublereal *h__, 
	doublereal *hd4i, doublereal *rabc, doublereal *alp, doublereal *alpn,
	 doublereal *cmar, doublereal *p, doublereal *s, doublereal *xp, 
	doublereal *yp, doublereal *ajkp, doublereal *u, doublereal *zfi)
{
    /* System generated locals */
    integer au_dim1, au_offset, ajk_dim1, ajk_offset, cmar_dim1, cmar_offset, 
	    ajkp_dim1, ajkp_offset, u_dim1, u_offset, zfi_dim1, zfi_offset, 
	    i__1, i__2;

    /* Local variables */
    static integer j, l, nu, kp1, kp2;
    static doublereal ksi;
    extern /* Subroutine */ int de70d0_c(S_fp, integer *, integer *, 
	    doublereal *, doublereal *, doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *, 
	    doublereal *), de71de_c(integer *, integer *, doublereal *, 
	    doublereal *, doublereal *, doublereal *), de71df_c(integer *, 
	    integer *, doublereal *, doublereal *, doublereal *), de70dh_c(
	    integer *, doublereal *, doublereal *), de70di_c(S_fp, integer *, 
	    integer *, integer *, doublereal *, doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *), de70df_c(integer *, 
	    integer *, doublereal *, doublereal *), de70dk_c(integer *, 
	    doublereal *, doublereal *, doublereal *, doublereal *, 
	    doublereal *, doublereal *);
    static integer iexit;

    /* Parameter adjustments */
    zfi_dim1 = *m;
    zfi_offset = 1 + zfi_dim1;
    zfi -= zfi_offset;
    ajkp_dim1 = *m;
    ajkp_offset = 1 + ajkp_dim1;
    ajkp -= ajkp_offset;
    --yp;
    ajk_dim1 = *m;
    ajk_offset = 1 + ajk_dim1;
    ajk -= ajk_offset;
    au_dim1 = *m;
    au_offset = 1 + au_dim1;
    au -= au_offset;
    --yx;
    u_dim1 = *m;
    u_offset = 1 + u_dim1;
    u -= u_offset;
    cmar_dim1 = *k;
    cmar_offset = 1 + cmar_dim1;
    cmar -= cmar_offset;
    --alpn;
    --alp;
    --rabc;
    --xj0;
    --hd4i;
    --p;
    --s;

    /* Function Body */
    kp1 = *k + 1;
    kp2 = *k + 2;
    *xp = *x;
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L45: */
	yp[l] = yx[l];
    }
    if (*jstart != 0) {
	goto L55;
    }

/*       THE FIRST STEP REALIZATION */
/*       CALCULATION OF ALL VARIABLES DEPENDING ON K */

    de70dk_c(k, &rabc[1], &alp[1], &alpn[1], &cmar[cmar_offset], &p[1], &s[1]);

/*       CALCULATION OF ALL VARIABLES DEPENDING ON H */
/*       AND ALSO VARIABLES DEPENDING ON H AND K */

    de70dh_c(k, h__, &hd4i[1]);
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
/* L50: */
	xj0[j] = *xp + alp[j] * *h__;
    }
    de70d0_c((S_fp)f, m, k, xp, &yp[1], &xj0[1], &alpn[1], &cmar[cmar_offset], 
	    &ajk[ajk_offset], &au[au_offset], &u[u_offset], &zfi[zfi_offset]);
    goto L110;

/*       THE NEXT STEP REALIZATION */

L55:
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
/* L60: */
	xj0[j] = *xp + alp[j] * *h__;
    }
/*       CHEBYSHEV COEFFICIENTS FROM PREVIOUS STEP ARE STORED */
    i__1 = kp1;
    for (j = 1; j <= i__1; ++j) {
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L65: */
	    ajkp[l + j * ajkp_dim1] = ajk[l + j * ajk_dim1];
	}
/* L70: */
    }
    if (*h__ == com70d_1.hold) {
	goto L80;
    }
    ksi = *h__ / com70d_1.hold;
/*       RECALCULATION OF ALL VARIABLS DEPENDING ON H */
    de70dh_c(k, h__, &hd4i[1]);
L80:
    if (*iniapr != 1) {
	goto L85;
    }
/*       CALCULATE INITIAL APPROXIMATION FROM INITIAL CONDITION ALWAYS */
    de70d0_c((S_fp)f, m, k, xp, &yp[1], &xj0[1], &alpn[1], &cmar[cmar_offset], 
	    &ajk[ajk_offset], &au[au_offset], &u[u_offset], &zfi[zfi_offset]);
    goto L110;
/*       CALCULATE INITIAL APPROXIMATION BY EXTRAPOLATION OF COEFFICIENTS */
/*       AJK FROM PREVIOUS STEP */
L85:
    if (*h__ == com70d_1.hold) {
	goto L90;
    }
    de71de_c(m, k, &p[1], &ajk[ajk_offset], &ksi, &zfi[kp2 * zfi_dim1 + 1]);
    goto L95;
L90:
    de71df_c(m, k, &s[1], &ajk[ajk_offset], &zfi[kp2 * zfi_dim1 + 1]);
L95:
    (*f)(xp, &yp[1], &zfi[zfi_dim1 + 1], m);
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L100: */
	zfi[l + zfi_dim1] *= com70d_1.wc2;
    }
L110:
    iexit = 0;
    i__1 = *imax;
    for (nu = 1; nu <= i__1; ++nu) {
	de70di_c((S_fp)f, m, k, &iexit, &yp[1], &xj0[1], &ajk[ajk_offset],
                &hd4i[1], &rabc[1], &alpn[1], &cmar[cmar_offset], &au[
		au_offset], &u[u_offset], &zfi[zfi_offset]);
/* L120: */
    }
    iexit = 3;
    de70di_c((S_fp)f, m, k, &iexit, &yp[1], &xj0[1], &ajk[ajk_offset], &hd4i[1],
            &rabc[1], &alpn[1], &cmar[cmar_offset], &au[au_offset], &u[u_offset],
            &zfi[zfi_offset]);
    de70df_c(m, &kp1, &au[au_offset], &yx[1]);
    *x = *xp + *h__;
    com70d_1.hold = *h__;
    *jstart = 1;
/* L200: */
    return 0;
} /* de44d_c */

